package edu.sjsu.rhinofaces;

import java.util.logging.Logger;

import javax.el.ELContext;
import javax.el.ExpressionFactory;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
   
   @author Tom Austin
 */
public class RhinoExpressionFactory extends ExpressionFactory
{
   private static Logger logger = Logger.global;
   
   private ExpressionFactory delegate;
   
   public RhinoExpressionFactory(ExpressionFactory delegate)
   {
      super();
      logger.info("Initializing RExpFact, with delegate of " + delegate);
      this.delegate = delegate;
   }

   @Override
   public MethodExpression createMethodExpression(ELContext context,
         String expression, Class expectedReturnType, Class[] expectedParamTypes)
   {
      logger.info("***CREATING METHOD EXPRESSION***");
      return new RhinoMethodExpression(delegate.createMethodExpression(context, expression,
            expectedReturnType, expectedParamTypes));
   }

   /**
      @see javax.el.ExpressionFactory#coerceToType(java.lang.Object, java.lang.Class)
    */
   @Override
   public Object coerceToType(Object arg0, Class<?> arg1)
   {
      return delegate.coerceToType(arg0, arg1);
   }

   /**
      @see javax.el.ExpressionFactory#createValueExpression(java.lang.Object, java.lang.Class)
    */
   @Override
   public ValueExpression createValueExpression(Object arg0, Class<?> arg1)
   {
      logger.info("*******Get val expression1");
      return delegate.createValueExpression(arg0, arg1);
   }

   /**
      @see javax.el.ExpressionFactory#createValueExpression(javax.el.ELContext, java.lang.String, java.lang.Class)
    */
   @Override
   public ValueExpression createValueExpression(ELContext arg0, String arg1, Class<?> arg2)
   {
      logger.info("*****Get val expression2");
      return delegate.createValueExpression(arg0, arg1, arg2);
   }
}
