/**
   Problem object.
 */
function Problem(question, answer) {
   this.question = question || null;
   this.answer = answer || null;
}

Problem.prototype.isCorrect = function(response) {
   return response.toLowerCase() == this.answer.toLowerCase();
}


/**
   Quiz controller.
 */
function Quiz() {
   this.currentProblem = 0;
   this.score = 0;
   this.tries = 0;
   this.response = "";
   
   this.problems = new Array();
   this.problems[0] = new Problem("What trademarked slogan describes Java development? Write once, ...",
            "run anywhere");
   this.problems[1] = new Problem("What are the first 4 bytes of every class file (in hexadecimal)?",
            "CAFEBABE");
   this.problems[2] = new Problem("What does this statement print? System.out.println(1+\"2\");",
         "12");
   this.problems[3] = new Problem("Which Java keyword is used to define a subclass?",
         "extends");
   this.problems[4] = new Problem("What was the original name of the Java programming language?",
         "Oak");
   this.problems[5] = new Problem("Which java.util class describes a point in time?",
         "Date");
   
   this.question = this.problems[this.currentProblem].question;
   this.answer = this.problems[this.currentProblem].answer;
}

Quiz.prototype.answerAction = function() {
   this.tries++;
   if (this.problems[this.currentProblem].isCorrect(this.response)) {
      this.score++;
      if (this.currentProblem == this.problems.length-1) return "done";
      else {
         this.nextProblem();
         return "success";
      }
   }
   else if (this.tries == 1) {
      return "again";
   }
   else {
      if (this.currentProblem == this.problems.length-1) return "done";
      else {
         this.nextProblem();
         return "failure";
      }
   }
}

Quiz.prototype.nextProblem = function() {
   this.currentProblem++;
   this.question = this.problems[this.currentProblem].question;
   this.lastAnswer = this.answer;
   this.answer = this.problems[this.currentProblem].answer;
   this.tries = 0;
   this.response = "";
}

Quiz.prototype.startOverAction = function() {
   this.currentProblem = 0;
   this.score = 0;
   this.tries = 0;
   this.response = "";
   this.question = this.problems[this.currentProblem].question;
   this.answer = this.problems[this.currentProblem].answer;
   //return "startOver";
   return "index";
}


quiz = new Quiz();